
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned char RevUartBuf[128];
unsigned long revCnt=0;        
unsigned char SiRevIntFlag=0;
unsigned char SiSendFlag=0;

void Io_Init(void);
void Uart_Init(void);
void Ext_Inter_Init(void);
void UartSendByte(unsigned char ch);
void UartSendStr(unsigned char *str);
void UartSendBuf(unsigned char *buf,unsigned long bufLength);
void Key_Scan(void);
void Si4432_Write_Register(unsigned char regAddr,unsigned char regVol);
unsigned char Si4432_Read_Register(unsigned char regAddr);
void Si4432_Send_Data(unsigned char *buf,unsigned char len);
void Si4432_Init(void);
unsigned char Si4432_Rev_Data(unsigned char *revBuf);
unsigned char Si4432_Get_Data(unsigned char *revBuf);

interrupt [2] void ext_int0_isr(void)
{
GIFR=0x40;
SiRevIntFlag=1;
}

interrupt [12] void usart_rx_isr(void)
{
if(SiSendFlag==0)
{
RevUartBuf[revCnt++]=UDR;
if( (RevUartBuf[revCnt-2]==0x0d)&&(RevUartBuf[revCnt-1]==0x0a) )
{
SiSendFlag=1;
}
if(revCnt>126)revCnt=0;
}
}

void Io_Init(void)
{

PORTA=0x13;
DDRA=0x0F;

PORTB=0x00;
DDRB=0x01;

PORTC=0x00;
DDRC=0x00;

PORTD=0xff;
DDRD=0x00;
}

void Uart_Init(void)
{

UCSRA=0x02;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x8F;
}

void Ext_Inter_Init(void)
{

GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;
}

void UartSendByte(unsigned char ch)
{
while(!(UCSRA&(1<<5)));
UDR=ch;
}

void UartSendStr(unsigned char *str)
{
while(*str)
{
UartSendByte(*str++);
}
}

void UartSendBuf(unsigned char *buf,unsigned long bufLength)
{
unsigned long i;
for(i=0;i<bufLength;i++)
{
UartSendByte(buf[i]);
}
}

void Key_Scan(void)
{
unsigned char buf[8]={0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
if(PIND.7==0)
{
delay_ms(10);
if(PIND.7==0)
{
while(PIND.7==0);
PORTB.0=~PORTB.0;
Si4432_Send_Data(buf,sizeof(buf));
}
}
}

void Si4432_Write_Register(unsigned char regAddr,unsigned char regVol)
{
unsigned char i;
regAddr|=0x80;	

PORTA.1=0;                              
delay_us(2);
for(i=0;i<8;i++)
{
if(regAddr&0x80)
{
PORTA.3=1;
}
else
{
PORTA.3=0;
}
PORTA.2=1;
delay_us(2);
PORTA.2=0; 
delay_us(1);           
regAddr=regAddr<<1;
}
for(i=0;i<8;i++)
{
if(regVol&0x80)
{
PORTA.3=1;
}
else
{
PORTA.3=0;
}
PORTA.2=1;
delay_us(2);
PORTA.2=0; 
delay_us(1);           
regVol=regVol<<1;
}
delay_us(2);
PORTA.1=1;    
}

unsigned char Si4432_Read_Register(unsigned char regAddr)
{
unsigned char i;
unsigned char Result=0;
regAddr&=0x7f;

PORTA.1=0; 	
delay_us(2);
for(i=0;i<8;i++)
{
if(regAddr&0x80)
{
PORTA.3=1;
}
else
{
PORTA.3=0;
}
PORTA.2=1;
delay_us(2);
PORTA.2=0; 
delay_us(1);           
regAddr=regAddr<<1;
}	
for(i=0;i<8;i++)
{                   
Result=Result<<1;
PORTA.2=1;
delay_us(1);         
if(PINA.4)
{
Result|=0x01;
}
PORTA.2=0;
delay_us(1);        
}
delay_us(2);
PORTA.1 = 1;                            
return Result;
}

void Si4432_Send_Data(unsigned char *buf,unsigned char len)
{
unsigned char i=0;

Si4432_Write_Register(0x07,0x01);																

Si4432_Write_Register(0x3E,len);	

for(i=0;i<len;i++)
{
Si4432_Write_Register(0x7F,buf[i]);  
}

Si4432_Write_Register(0x05,0x04);	
Si4432_Write_Register(0x06,0x00);	

Si4432_Read_Register(0x03);	
Si4432_Read_Register(0x04);	

Si4432_Write_Register(0x07,0x09);

while(PIND.2==1);

Si4432_Read_Register(0x03);
Si4432_Read_Register(0x04);

Si4432_Write_Register(0x05,0x03); 
Si4432_Write_Register(0x06,0x00); 

Si4432_Read_Register(0x03);	
Si4432_Read_Register(0x04);	

Si4432_Write_Register(0x07,0x05);	   	
}

unsigned char Si4432_Rev_Data(unsigned char *revBuf)
{
unsigned char i=0;
unsigned char len=0;
unsigned char ItStatus1=0;
unsigned char ItStatus2=0;
unsigned long timerOut=0x3fff;
while(timerOut!=0)
{
timerOut--;
if(PIND.2==0)  
{

Si4432_Write_Register(0x07,0x01);

ItStatus1=Si4432_Read_Register(0x03);	
ItStatus2=Si4432_Read_Register(0x04);	

if((ItStatus1&0x01)== 0x01)
{

Si4432_Write_Register(0x08,0x02);	
Si4432_Write_Register(0x08,0x00);	
}

if((ItStatus1&0x02)==0x02)
{

len=Si4432_Read_Register(0x4B);	

for(i=0;i<len;i++)
{
revBuf[i]=Si4432_Read_Register(0x7F);	
}
UartSendBuf(revBuf,len);
}

Si4432_Write_Register(0x08,0x02);	
Si4432_Write_Register(0x08,0x00);	

Si4432_Write_Register(0x07,0x05);	
}  
}
return len;
}

unsigned char Si4432_Get_Data(unsigned char *revBuf)
{
unsigned char i=0;
unsigned char len=0;
unsigned char ItStatus1=0;
unsigned char ItStatus2=0;

Si4432_Write_Register(0x07,0x01);

ItStatus1=Si4432_Read_Register(0x03);	
ItStatus2=Si4432_Read_Register(0x04);	

if((ItStatus1&0x01)== 0x01)
{

Si4432_Write_Register(0x08,0x02);	
Si4432_Write_Register(0x08,0x00);	
}

if((ItStatus1&0x02)==0x02)
{

len=Si4432_Read_Register(0x4B);	

for(i=0;i<len;i++)
{
revBuf[i]=Si4432_Read_Register(0x7F);	
}
UartSendBuf(revBuf,len);
}

Si4432_Write_Register(0x08,0x02);	
Si4432_Write_Register(0x08,0x00);	

Si4432_Write_Register(0x07,0x05);	

return len;
}

void Si4432_Init(void)
{

PORTA.0=0;

delay_ms(20);

Si4432_Read_Register(0x03);
Si4432_Read_Register(0x04);

Si4432_Write_Register(0x07,0x80);    

while(PIND.2==1);

Si4432_Read_Register(0x03);
Si4432_Read_Register(0x04);                                                 

while(PIND.2==1);

Si4432_Read_Register(0x03);
Si4432_Read_Register(0x04);  

Si4432_Write_Register(0x75,0x53);															
Si4432_Write_Register(0x76,0x64);															
Si4432_Write_Register(0x77,0x00); 

Si4432_Write_Register(0x2a,0x14);	
Si4432_Write_Register(0x6E,0x09);														
Si4432_Write_Register(0x6F,0xd5);															
Si4432_Write_Register(0x70,0x2C);	

Si4432_Write_Register(0x72,0x38);	

Si4432_Write_Register(0x1C,0x1b);		
Si4432_Write_Register(0x20,0x83);		
Si4432_Write_Register(0x21,0xc0);		
Si4432_Write_Register(0x22,0x13);		
Si4432_Write_Register(0x23,0xa9);		
Si4432_Write_Register(0x24,0x00);		
Si4432_Write_Register(0x25,0x03);		
Si4432_Write_Register(0x1D,0x40);		
Si4432_Write_Register(0x1E,0x0A);		
Si4432_Write_Register(0x2A,0x14);		

Si4432_Write_Register(0x34, 0x0A);	

Si4432_Write_Register(0x35,0x2A); 	

Si4432_Write_Register(0x33,0x02);	

Si4432_Write_Register(0x36,0x2D);   
Si4432_Write_Register(0x37,0xD4);	

Si4432_Write_Register(0x30,0x8D);	

Si4432_Write_Register(0x32,0x00 );	

Si4432_Write_Register(0x71,0x63);	

Si4432_Write_Register(0x0C,0x15);	
Si4432_Write_Register(0x0b,0x12);	

Si4432_Write_Register(0x09,0xD7);	

Si4432_Write_Register(0x69,0x60);	

Si4432_Write_Register(0x6d,0x1e);	

Si4432_Write_Register(0x07,0x05);

Si4432_Write_Register(0x05,0x03); 
Si4432_Write_Register(0x06,0x00); 

Si4432_Read_Register(0x03);	
Si4432_Read_Register(0x04);	

Si4432_Write_Register(0x07,0x05);

Si4432_Write_Register(0x0d,0xf4);	
}

void Read_Reg_Test(void)
{
unsigned char buf[32]={0};
unsigned char dat=0;

dat=Si4432_Read_Register(0x75);	
sprintf(buf,"Si4432_Read_Register(0x75)=%02x\r\n",dat);
UartSendStr(buf);

dat=Si4432_Read_Register(0x76);	
sprintf(buf,"Si4432_Read_Register(0x76)=%02x\r\n",dat);
UartSendStr(buf);

dat=Si4432_Read_Register(0x77);	
sprintf(buf,"Si4432_Read_Register(0x77)=%02x\r\n",dat);
UartSendStr(buf);
}

void main(void)
{
char *str="start...\r\n";
unsigned char buf[128]={0};
delay_ms(100);
Io_Init();
Uart_Init();
Ext_Inter_Init();
Si4432_Init();
#asm("sei")
UartSendStr(str);
Read_Reg_Test();
while (1)
{
Key_Scan();
if(SiRevIntFlag)
{
SiRevIntFlag=0;
Si4432_Get_Data(buf);
}
if(SiSendFlag)
{
Si4432_Send_Data(RevUartBuf,revCnt);
revCnt=0;
SiSendFlag=0;
}

};
}
